args <- commandArgs(trailingOnly = TRUE)
Q=as.numeric(args[2])
tempdir=args[3]

# Perturbated kmeans
fname = paste(tempdir,"/kmeans_Q",Q,".groups",sep="")
labels = read.table(fname)$V1
kmr = read.table(fname)$V2
n = length(kmr)
smax=as.integer(15*n/100)
smin=as.integer(5*n/100)
nbs = sample(smin:smax,1)
v = sample(1:n, nbs)
vs = sample(v, nbs)
kmr[v] = kmr[vs]
fname = paste(tempdir,"/pkmeans_Q",Q,".groups",sep="")
writeLines("# Colors", con=fname)
write(t(cbind(labels, kmr)), file=fname, ncolumns=2, append=T)
