#include<ColoredWeightedGraph.hpp>
#include<iostream>
#include <assert.h>
using namespace std;
using namespace mixsnet;
int main(int argc, char **argv)
{
  ColoredWeightedGraph<int> g(argv[1]);
// cout<<g.nbVertices()<<" vertices"<<endl;
  assert(g.nbVertices() == 4);
  typedef ColoredWeightedGraph<int>::Vertex Vertex;
  string name = "toto";
  Vertex vnew = boost::add_vertex(g);
  g.setName(vnew, name);
  g.setColor(vnew, 1);
  typedef ColoredWeightedGraph<int>::EdgeIterator EdgeIterator;
  EdgeIterator it = g.edgesBegin(), itend = g.edgesEnd();
  for (; it != itend; it++){
//    cout<< "(" << source(*it, g)
//             << "," << target(*it, g)  << "," << g.getWeight(*it) << ")" << endl;
  }
  typedef ColoredWeightedGraph<int>::OutEdgeIterator OutEdgeIterator;
  Vertex v0 = vertex(0, g);
  OutEdgeIterator ito = g.outEdgesBegin(v0), itoend = g.outEdgesEnd(v0);
  assert(g.getWeight(*ito) == 1);
  for (; ito != itoend; ito++){
//    cout<< "(" << source(*ito, g)
//             << "," << target(*ito, g)  << "," << g.getWeight(*ito) << ")" << endl;
  }
  assert(g.convertToIndex(g.getName(v0)) == 0);


  ColoredRoadNetwork<int> net(argv[1]);
  unsigned int nbv = net.nbVertices();
  net.allShortestPath();
  for (unsigned int i=0; i<nbv; i++){
//    for (unsigned int j=0; j<nbv; j++)
//      cout<<net.shortestPath(i, j)<<" ";
//    cout<<endl;
  }
  assert(net.shortestPath(0, 1) == 1);
  return 0;
}
