#include<GaussianDistribution.hpp>
#include<iostream>
#include<math.h>
#include<assert.h>
using namespace std;
using namespace placeholders;
using namespace mixsnet;
int main(int argc, char **argv)
{
  ColoredRoadNetwork<int> net(argv[1]);
  Matrix<double> mat;
  mat.read(argv[2], net.getConvertToIndexFunction());
  std::cerr<<mat<<std::endl;

  InflatedDistribution<HomoscedasticGaussian> dist(2, 1.);
  dist.compute(net, mat);
  assert(abs(dist.getBetaql(0,0)-0.5)<0.0000001);
  return 0;
}
